package com.googelcode.jpractices;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.apache.commons.beanutils.BeanPredicate;
import org.apache.commons.collections.CollectionUtils;

import com.googelcode.jpractices.common.Person;


/**
 * Copyright 2009 @ jPractices v 1.0
 * @SVN URL : http://jpractices.googlecode.com
 * @author Ganesh Gowtham
 * @Homepage : http://ganesh.gowtham.googlepages.com
 * @Description : Writing the own predicate to filter the person objects whose salary is
 * 				greater than 26000
 */
public class CustomPredicateExample {
	List<Person> personList = new ArrayList<Person>();

	/**
	 * Basic method which creates the list of person object's
	 */
	void setUpData() {
		personList.add(new Person("ganesh", "gowtham", 25000));
		personList.add(new Person("britney", "spears", 45000));
		personList.add(new Person("ganesh", "tom", 35000));
		personList.add(new Person("sunny", "dummy", 45000));
	}

	void filterCollection(int salary)
	{
		SalaryHighPredicate nameEqlPredicate = new SalaryHighPredicate(salary);
		BeanPredicate beanPredicate = new BeanPredicate("salary", nameEqlPredicate);
		Collection<Person> filteredCollection = CollectionUtils
					.select(personList, beanPredicate);
		System.out.println("Shows the person object whose salary is >= 26,000 ");
		for (Person person : filteredCollection) {
			System.out.println(person);
		}
	}
	public static void main(String[] args) {

		CustomPredicateExample example = new CustomPredicateExample();
		example.setUpData();
		example.filterCollection(26000);
	}
}
